﻿<%@ Page Language="vb" AutoEventWireup="false" CodeBehind="Chapter4.aspx.vb" Inherits="SFAnthemAJAXExample.Chapter4" %>

<%@ Register Src="wucSidebar1.ascx" TagName="wucSidebar1" TagPrefix="uc1" %>
<%@ Register Src="wucSidebar2.ascx" TagName="wucSidebar2" TagPrefix="uc2" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head id="Chapter4" runat="server">
    <meta http-equiv="content-type" content="text/html; charset=utf-8" />
    <title>SF - AJAX Communnity Sample: Chapter 4</title>

    <meta name="keywords" content="" />
    <meta name="description" content="" />

    <link href="CSS/default.css" rel="stylesheet" type="text/css" media="screen" />
    <link href="CSS/SFAJAX.css" rel="stylesheet" type="text/css" media="screen" />

    <script src="Scripts/SFAJAX.js" type="text/javascript" ></script>
    <script type="text/javascript" language="javascript" >
        
        /* 
        ----------------------------------------------------------------------------------------
        This method simply initializes the form on load so that the DIV named "searchresults"
        is hidden when the body of the document first loads and that the "keyword" text box
        receives focus ready for typing.  Examine the <body> tag below to see how this is called.
        -----------------------------------------------------------------------------------------
        */
        function bodyLoad()
        {
            HideControl("searchresults");
            document.getElementById("keyword").focus();
        }

        function LoadResults(searchterm)
        {
        if (searchterm.length == 0)
        {
            ClearResults("searchresults");
            HideControl("searchresults");
            return;
        }
        Anthem_InvokePageMethod('RetrieveRows',[searchterm], LoadResultsCallback);
        }

        function LoadResultsCallback(result)
        {
            ShowControl("searchresults");
            ClearResults("searchresults");

            var divResults = document.getElementById("searchresults");
            var tblTable = document.createElement("table");
            var tablebody = document.createElement("tbody");
            var tablerow, tablecell, tablenode;
            
            if(typeof(result.error) == 'string')
            {
                var currenttext = result.error;
                tablerow = document.createElement("tr");
                tablecell = document.createElement("td");
                tablenode = document.createTextNode(currenttext);
                tablecell.appendChild(tablenode);
                tablerow.appendChild(tablecell);
                tablebody.appendChild(tablerow);                    
                tblTable.appendChild(tablebody);
                divResults.appendChild(tblTable);
                return;	
            }
                        
            var items = result.value;
            var count = items.Rows.length;
            
            for ( var i = 0; i < count; i++)
            {
                var currenttext = items.Rows[i].CustomerName;
              
                tablerow = document.createElement("tr");
                tablecell = document.createElement("td");
                tablecell.onmouseover = function(){this.className='gsMouseOver';};
                tablecell.onmouseout = function(){this.className='gsMouseOut';};
                tablecell.setAttribute("border","0");
                tablecell.onclick = function(){ReplaceInput(this);};
                tablenode = document.createTextNode(currenttext);
                tablecell.appendChild(tablenode);
                tablerow.appendChild(tablecell);
                tablebody.appendChild(tablerow);
            }
            tblTable.appendChild(tablebody);
            divResults.appendChild(tblTable);
        }

        function ReplaceInput(tablecell)
        {
            var inputbox = document.getElementById("keyword");
            inputbox.value = tablecell.firstChild.nodeValue;
            ClearResults("searchresults");
            HideControl("searchresults");
        }
                        
    </script>
    
</head>

<body onload="bodyLoad()">

    <form id="frmChapterFour" runat="server">
    
        <span id="AjaxMessage"></span>
        
        <div id="wrapper">
	                <!-- start menu -->
	                <div id="menu">
		                <ul>
			                <li><a href="Default.aspx">Home</a></li>
			                <li><a href="Contact.aspx">Contact</a></li>
		                </ul>
	                </div>
	                <!-- end menu -->
	                <!-- start header -->
	                <div id="header">
		                <div id="logo">
			                <h1><img src="Images/SFHeader.jpg" alt=""/></h1>
			                <p>with 
			                    <span style="color: #990000">
			                    <strong>AJAX</strong>
			                    <br />
                                </span>
                                <br />
                                <span style="font-size: 0.65em">
                                A free sample by Charles T. Blankenship & Anthony Somma
                                </span>
                            </p>
		                </div>
	                </div>
	                <!-- end header -->
	                <!-- start page -->
	                <div id="page">
		                <div id="bgtop"></div>
		                <div id="bgbottom">
			                <!-- start content -->
			                <div id="content" style="width: 695px">
				                <div class="post">
					                <div class="bigpix">
						                <div class="image"><img src="Images/FireFlies.png" alt="" height="250" style="width: 695px" /></div>
						                <p class="caption">
                                            What is this Anthem thing and why is it important?</p>
					                </div>
					                <h1 class="title"><a href="#">Chapter 4: A Google Suggest Example</a></h1>
					                <div class="entry">

						                <strong>
						                Google Suggest allows you to type a search term into a text box.  It then looks into 
						                the Google database for other popular entries that match or closely match the search
						                string that you just entered and displays them to you ... all without a postback to the server.&nbsp; That is the function this example will recreate with one caveat,
                                            we will be using the Customers table in StrataFrame's sample database instead of hacking into Google's database.
						                <br />                                        
                                        <br />
                                        </strong>
                                        
                                        <h2>
                                        </h2>
                                        <strong style="font-family: Arial"></strong>
                                        <h2>
                                            google suggest demonstration</h2>
                                        <strong style="font-family: Arial"></strong>
                                        <table border="0" 
                                               cellpadding="0" 
                                               cellspacing="0">
                                            <tr>
                                                <td>
                                                    Enter the name of a StrataFrame Customer:
                                                </td>
                                            </tr>
                                            <tr>
                                                <td>
                                                    <asp:TextBox ID="keyword" 
                                                                 runat="server" 
                                                                 Width="400px" ></asp:TextBox>
                                                </td>
                                            </tr>
                                            <tr>
                                                <td style="height: 100%">
                                                    <div class="box" 
                                                         id="searchresults" 
                                                         style=" text-align:left;height:100%;width:100%;background-color:#e0edf6; font-size: 12px; font-family: Arial;">
                                                    </div>
                                                </td>
                                            </tr>
                                        </table>
                                        <br />
                                        <h2>design considerations</h2>
                                        <p> There are several design considerations for this example and they are as follows:</p>
                                        <ul>
                                            <li>When a user presses a key, search the Customers table for all records that match
                                                the currently entered string, this includes removing the character using the backspace
                                                key. </li>
                                            <li>Entering a comma indicates the separation between last name and first name, therefore,
                                                entering "Sm,A" should return all Customers with "Sm" in the first two characters
                                                of their last name and a character "A" as the first character of the first name.</li>
                                            <li>The backcolor must change when a user mouses over a particular selection.</li>
                                            <li>Clicking on a selection clears the list and populates the textbox with the selected name.</li>
                                            <li>All must occur with no round trip being evident to the user</li>
                                        </ul>
                                        <h2>description</h2>
                                        <h3>The Business Object</h3>
                                        <p>Let's start at the data tier and work forward this time.  As most of you know, a
                                            StrataFrame Web Application should always reference a business object library that
                                            exists as a separate project in the solution.&nbsp; If you are in the design environment
                                            for this page look to the right (probably) and notice the very first project in
                                            the solution explorer is BOLibrary and it contains all of the business objects that
                                            interface with this project and the data store (SQL Server).&nbsp; Since we need
                                            to receive data from the Customers table, double click on the Customers.vb class
                                            and instantiate it.&nbsp; Notice the method named as such.</p>                                        
                                        <p><img id="imgChapter4_1" src="Images/Chapter4_1.png" alt=""/></p>
                                        <p>
                                            One of the very, very cool things about StrataFrame is the plethora of methods we
                                            can use to retrieve data from the server.&nbsp; Specifically I want to focus on
                                            the Get and Fill methods.&nbsp; Simply put, the Get methods return a datatable without
                                            affecting the status of the CurrentDataTable (the table upon which the business
                                            object performs functions such as save, delete, etc.)&nbsp; The Get methods simply
                                            return a datatable that meets the criteria of your SQL query and allows you to use
                                            it as you wish (process with it ... return it to the interface, etc).&nbsp; More
                                            specifically, you will want to use Fill methods if you want to bind the BO data
                                            element properties to a control on the interface.&nbsp; In our situation; however,
                                            we only want to display a list of names that meet the search critera, therefore,
                                            we should use a Get method, even more specifically, the GetDataTable method.</p>
                                        <p>
                                            Notice how easy it is to get a data table from SQL Server in StrataFrame using the
                                            SqlCommand object, populating it and passing it as a parameter to the GetDataTable
                                            method.</p>
                                        <p><img id="imgChapter4_2" src="Images/Chapter4_2.png" alt="" /></p>
                                        <p>
                                            Notice how the parameters are first coded into the SQL Command Text string, then
                                            are programmatically appended and populated with values prior to passing the command
                                            object into the method.&nbsp; This means of creating parameters prevents SQL Injection
                                            kind of attacks from occuring.&nbsp;</p>
                                        <p>
                                            Once the data is retrieved, it is returned to the calling program (the code behind
                                            page of the interface), where it is then returned to the actual page and processed
                                            by the JavaScript.</p>
                                        <h3>Chapter4.aspx.vb (the code behind page)</h3>
                                        <p>
                                            Notice just how painfully simple the code behind page is for Chapter 4.&nbsp; Since
                                            all of the processing logic is encapsulated in the business object (where it can
                                            be reused in a WinForms application if necessary) all this page really does is pass
                                            the request from the user / interface to the business object and then relay the
                                            results back to the interface for the JavaScript to work with.&nbsp; Notice that
                                            it contains the obligatory registration with the Anthem manager as well as the label
                                            for the method identifying it as an Anthem method.</p>
                                        <p><img src="Images/Chapter4_3.png" alt="" /></p>
                                        <h3>Chapter4.aspx</h3>
                                        <p>
                                            The HTML markup for this page is also rather simple.&nbsp; It consists of a table
                                            that contains a text box named "keyword" and a div tag named "searchresults".  
                                        </p>
                                        <img src="Images/Chapter4_4.png" alt=""/>
                                        <p>
                                            If you have already played with the example a bit, you know that the trigger to
                                            lookup the list of names occurs during the "onkeyup" JavaScript event.&nbsp; However,
                                            a close examination of the HTML markup shows no onkeyup() assignment.&nbsp; That
                                            is because this occurs in the Page_Load event of the code behind, scroll up and
                                            take a closer look at image for the code behind page and notice the call to the
                                            text box's, Attributes.Add method.&nbsp; This is how JavaScript functions are assigned
                                            to events for controls that contain a runat="server" tag.&nbsp;
                                        </p>
                                        <img src="Images/Chapter4_5.png" alt=""/>
                                        <p>
                                        So, we know that when a user presses a key and releases it, the JavaScript event 
                                        onkeyup() takes over and calls the LoadResults() JavaScript function and passes
                                        into it the current value of the textbox named "keyword".  The loadresults() function
                                        checks to see if the length of the search term is 0, if it is, it clears the results
                                        from the div tag and hides it from view. If a value is entered, the RetrieveRows() method
                                        of the code behind page is called, the content of the textbox is passed into it as a 
                                        parameter and the LoadResultsCallback() JavaScript function is designated as the 
                                        handler for the datatable that is returned from the database.
                                        </p>
                                        <img src="Images/Chapter4_6.png" alt=""/>
                                        <p>
                                        The LoadResults() JavaScript function performs its duties in two steps, the first step
                                        determines if the result contains a string attribute by the name of error.  If it does,
                                        it displays the content of this error to the user and does not bother with the next step.
                                        I had to put this into the processing after I tried to run this application as a regular
                                        web site using IIS.  At this time, the ASPNET service had no rights to access the StrataFrameSample
                                        database and the application would not work, I couldn't figure out why, until I realized it
                                        was the connection that was failing and I wasn't receiving any error information from the backend.
                                        <br /> <br />
                                        If no errors are detected, then the JavaScript programmatically takes on the job of 
                                        building an HTML table using the functions available to the Document Object Model.  First, 
                                        it creates Table, then a Body, then a Row, then a Cell, assigns some important JavaScript
                                        functions to events that should trigger (onmouseover(), onmouseout(), onclick()), and then 
                                        assigns the value returned from the database to the tablenode object.  <br /> <br /> I cannot
                                        stress enough the importance of JavaScript in web development.  I can't believe it took this 
                                        long for me to discover the power of this language and the benefits it yields to web developers.
                                        </p>
                                        <h2>conclusion</h2>
                                        <p>
                                        Well, that's about it for the Google Suggest example, I'll turn it into a Web User Control and 
                                        use it in a production environment for Chapter 8, A Basic Create, Read, Update and Delete Example.
                                        Notice that there is no primary key associated with this example, as it stands it is pretty useless
                                        if we want to use it to fetch a record for maintenance ... I'll rectify this little problem as well.
                                        </p>
                                    </div>
                					
				                </div>
				                
			                </div>
			                <!-- end content -->
			                <!-- start sidebar one -->
			                <!-- end sidebar one -->
			                <!-- start sidebar two -->
			                <uc2:wucSidebar2 ID="WucSidebar2_1" runat="server" />
			                <!-- end sidebar two -->
			                <div style="clear: both;">&nbsp;</div>
		                </div>
	                </div>
	                <!-- end page -->
	                <hr />
	                <!-- start footer -->
	                <div id="footer">
	                </div>
	                <!-- end footer -->
                </div>
    </form>
</body>
</html>
